src/config/urls.py
from django.contrib import admin
from django.urls import path, include

from students.views import IndexView, PageNotFoundView

urlpatterns = [
    path("__debug__/", include("debug_toolbar.urls")),
    path("admin/", admin.site.urls),
    path("groups/", include("groups.urls")),
    path("students/", include("students.urls")),
    path("teachers/", include("teachers.urls")),
    path("", IndexView.as_view(), name="index"),
    path("oauth/", include("social_django.urls", namespace="social")),
]


handler404 = PageNotFoundView.as_view()

src/teachers/urls.py
from django.urls import path

from teachers.views import (
    CreateTeacherView,
    GetTeachersView,
    UpdateTeacherView,
    DeleteTeacherView,
)

app_name = "teachers"

urlpatterns = [
    path("", GetTeachersView.as_view(), name="get_teachers"),
    path("create/", CreateTeacherView.as_view(), name="create_teacher"),
    path("update/<uuid:pk>/", UpdateTeacherView.as_view(), name="update_teacher"),
    path("delete/<uuid:pk>/", DeleteTeacherView.as_view(), name="delete_teacher"),
]

src/teachers/models.py
import uuid

from django.core.validators import MinLengthValidator
from django.db import models
from faker import Faker

from students.models import Person


class Teacher(Person):
    id = models.UUIDField(
        primary_key=True, unique=True, editable=False, default=uuid.uuid4
    )
    first_name = models.CharField(
        max_length=128, null=True, validators=[MinLengthValidator(2)]
    )
    specialization = models.CharField(max_length=128, null=True)
    academic_degree = models.CharField(max_length=256, null=True)
    group = models.ManyToManyField(to="groups.Group")

    def __str__(self):
        return f"{self.first_name} {self.last_name}"

    @classmethod
    def generate_instances(cls, count):
        faker = Faker()
        for _ in range(count):
            cls.objects.create(
                first_name=faker.first_name(),
                last_name=faker.last_name(),
                email=faker.email(),
                birthdate=faker.date_between(start_date="-80y", end_date="-18y"),
                specialization=faker.word(
                    ext_word_list=[
                        "Early Childhood Special Education",
                        "Applied Behavior Analysis",
                        "Visual and/or Hearing Impairment",
                        "English as a Second Language",
                        "Education Administration",
                    ]
                ),
                academic_degree=faker.suffix(),
            )

src/teachers/forms.py
from django.core.exceptions import ValidationError
from django.forms import ModelForm
from teachers.models import Teacher


class TeacherForm(ModelForm):
    class Meta:
        model = Teacher
        fields = ("first_name", "last_name", "email")

    @staticmethod
    def normalize_text(text):
        return text.strip().capitalize()

    def clean_first_name(self):
        return self.normalize_text(self.cleaned_data["first_name"])

    def clean_last_name(self):
        return self.normalize_text(self.cleaned_data["last_name"])

    def clean(self):
        cleaned_data = super().clean()
        first_name = cleaned_data["first_name"]
        last_name = cleaned_data["last_name"]

        if first_name == last_name:
            raise ValidationError("First name and last name can't be equal")

src/teachers/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.forms.utils import ErrorList
from django.urls import reverse_lazy
from django.views.generic import ListView, CreateView, UpdateView, DeleteView

from teachers.models import Teacher


class GetTeachersView(LoginRequiredMixin, ListView):
    login_url = reverse_lazy("students:user_login")
    template_name = "teachers-list.html"
    model = Teacher


class CreateTeacherView(LoginRequiredMixin, CreateView):
    login_url = reverse_lazy("students:user_login")
    template_name = "teachers-create.html"
    http_method_names = ["get", "post"]
    model = Teacher
    fields = "__all__"
    success_url = reverse_lazy("teachers:get_teachers")

    def form_valid(self, form):
        self.object = form.save(commit=False)
        first_name = form.cleaned_data["first_name"]
        last_name = form.cleaned_data["last_name"]
        if first_name == last_name:
            form._errors["first_name"] = ErrorList(
                ["First name and last name can't be equal"]
            )
            return super().form_invalid(form)
        return super().form_valid(form)


class UpdateTeacherView(LoginRequiredMixin, UpdateView):
    login_url = reverse_lazy("students:user_login")
    template_name = "teachers-edit.html"
    http_method_names = ["get", "post"]
    model = Teacher
    fields = "__all__"
    success_url = reverse_lazy("teachers:get_teachers")

    def form_valid(self, form):
        self.object = form.save(commit=False)
        first_name = form.cleaned_data["first_name"]
        last_name = form.cleaned_data["last_name"]
        if first_name == last_name:
            form._errors["first_name"] = ErrorList(
                ["First name and last name can't be equal"]
            )
            return super().form_invalid(form)
        return super().form_valid(form)


class DeleteTeacherView(LoginRequiredMixin, DeleteView):
    login_url = reverse_lazy("students:user_login")
    template_name = "teachers_confirm_delete.html"
    http_method_names = ["get", "post"]
    model = Teacher
    success_url = reverse_lazy("teachers:get_teachers")

src/teachers/templates/teachers-create.html
{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <form method="POST">
        {% csrf_token %}
        <p>New teacher</p>
        <br>
        {{ form|crispy }}
        <br>
        <p>
            <button type="submit" value="Create" class="btn btn-success">Create</button>
        </p>
    </form>
{% endblock %}

src/teachers/templates/teachers-edit.html
{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <form method="POST">
        {% csrf_token %}
        <p>Edit teacher</p>
        <br>
        {{ form|crispy }}
        <br>
        <p>
            <button type="submit" value="Create" class="btn btn-success">Update</button>
        </p>
    </form>
{% endblock %}

src/teachers/templates/teachers-list.html
{% extends "index.html" %}

{% block content %}
    <table class="table table-dark table-striped">
        <thead>
        <tr>
            <th scope="col">First name</th>
            <th scope="col">Last name</th>
            <th scope="col">Email</th>
            <th scope="col">Birthdate</th>
            <th scope="col">Groups</th>
            <th scope="col">Edit</th>
            <th scope="col">Delete</th>
        </tr>
        </thead>
        <tbody>
        {% for teacher in object_list %}
            <tr>
                <td>{{ teacher.first_name }}</td>
                <td>{{ teacher.last_name }}</td>
                <td>{{ teacher.email }}</td>
                <td>{{ teacher.birthdate }}</td>
                <td>
                    {% for each_group in teacher.group.all %}
                        {{ each_group }}<br>
                    {% endfor %}
                </td>
                <td><a type="button" class="btn btn-warning"
                       href="{% url "teachers:update_teacher" teacher.id %}">Edit</a></td>
                <td><a type="button" class="btn btn-danger"
                       href="{% url "teachers:delete_teacher" teacher.id %}">Delete</a></td>
            </tr>
        {% endfor %}
        </tbody>
    </table>
{% endblock %}

src/teachers/templates/teachers_confirm_delete.html
{% extends "index.html" %}
{% load crispy_forms_tags %}

{% block content %}
    <div>
        <form method="post">{% csrf_token %}
            <p>Are you sure you want to delete "{{ object }}"?</p>
            {{ form|crispy }}
            <input type="submit" value="Confirm">
        </form>
    </div>
{% endblock %}